Subject: Re: [magma] Querier transition based on Group Specific Query?

From: Bharat Joshi <[email-masked]>
Date: Wed, 1 Feb 2012 18:47:35 +0530

Magesh,

       The snippet you have copied in your mail is from the last para of section 3 of RFC 2236. In the same section, in second para of the same section, we have following text:

If a multicast router hears a  Query message from a router with a lower IP address, it MUST become a  Non-Querier on that network.

<<<<

       Please note that the above text uses 'Query message' and it does not clearly says which query message. In RFC 2236, querier election has used either 'Query' or 'Membership Query' interchangeably. I could not find an instance where it clearly says that it must be only general query messages.

       Also I just checked the state diagram also and in Non-querier case also, it just mention that if a 'query' is received from a lower IP address. It does not mention what type of query it is.

       So as far as I can see, this is not clear from the RFC.

Regards,
Bharat
________________________________________
From: V, Magesh (Magesh) [[email-masked]]
Sent: Wednesday, February 01, 2012 6:35 PM
To: Bharat Joshi; Indranil Bhattacharya
Cc: [email-masked]
Subject: RE: [magma] Querier transition based on Group Specific Query?

Hi,
I believe querier election is driven by only Gen.Quer msgs. An igmp router can be in either 'Querier' or 'Non-Querier' state.
Since GSQs will be sent only by 'Querier' then we have to see what a 'Non-Querier' is recommended to do upon reception of GSQ.
The 'Non-Querier' should ONLY update its grp membership timer. The below snippet from last paragraph of section-3 explains this.

<<<<<<<<<<<<<<<<<<<<
When a non-Querier receives a Group-Specific Query message, if its
   existing group membership timer is greater than [Last Member Query
   Count] times the Max Response Time specified in the message, it sets
   its group membership timer to that value.

Also, the 'Non-Querier' state diagram reiterates the above interpretation.

Thanks,
Magesh.

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Bharat Joshi
Sent: Tuesday, January 31, 2012 7:39 PM
To: Indranil Bhattacharya
Cc: [email-masked]
Subject: Re: [magma] Querier transition based on Group Specific Query?

Indranil.

       Looks like what you are saying is correct.

       So it seems querier election logic should run when either group-specific queries or general queries are received.

Regards,
Bharat
________________________________________
From: Indranil Bhattacharya [[email-masked]]
Sent: Tuesday, January 31, 2012 7:24 PM
To: Bharat Joshi
Cc: [email-masked]
Subject: Re: [magma] Querier transition based on Group Specific Query?

Hi Bharat,

              RFC 2236, from Section 2.1

0x11 = Membership Query
        There are two sub-types of Membership Query messages:
        - General Query, used to learn which groups have members on an
          attached network.
        - Group-Specific Query, used to learn if a particular group
          has any members on an attached network.

         So Membership Query means both.

Thanks,
Indranil

On Tue, Jan 31, 2012 at 7:00 PM, Bharat Joshi <[email-masked]<mailto:[email-masked]>> wrote:
Hi Indranil,

     Is this defined in an RFC like that? Can you point me to the reference where it says what you mean below?

     I just did a google search on this and few top results for this seems to refer to general query only.

Regards,
Bharat
________________________________________
From: Indranil Bhattacharya [[email-masked]<mailto:[email-masked]>]
Sent: Tuesday, January 31, 2012 6:58 PM
To: Bharat Joshi
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: [magma] Querier transition based on Group Specific Query?

Hi Bharat,

             "IGMP Membership Query"query does not mean only General Query. It means both GQ and GSQ. Anything on this?

Thanks,
Indranil

On Tue, Jan 31, 2012 at 4:33 PM, Bharat Joshi <[email-masked]<mailto:[email-masked]><mailto:[email-masked]<mailto:[email-masked]>>> wrote:
Hi Indranil,

       I think a router should always be looking at general queries.

       This is what is available in RFC 2236:

 The following three events can cause the router to change states:

 - "query timer expired" occurs when the timer set for query
   transmission expires.

 - "query received from a router with a lower IP address" occurs when
   an IGMP Membership Query is received from a router on the same
   network with a lower IP address.

 - "other querier present timer expired" occurs when the timer set to
   note the presence of another querier with a lower IP address on the
   network expires.

<<<

   The second point clearly says that it should be an "IGMP Membership Query" which can trigger a change in querier state.

Regards,
Bharat
________________________________________
From: [email-masked]<mailto:[email-masked]><mailto:[email-masked]<mailto:[email-masked]>> [[email-masked]<mailto:[email-masked]><mailto:[email-masked]<mailto:[email-masked]>>] On Behalf Of Indranil Bhattacharya [[email-masked]<mailto:[email-masked]><mailto:[email-masked]<mailto:[email-masked]>>]
Sent: Tuesday, January 31, 2012 8:56 AM
To: [email-masked]<mailto:[email-masked]><mailto:[email-masked]<mailto:[email-masked]>>
Subject: [magma] Querier transition based on Group Specific Query?

Hi,

 In the querier transition state machine, RFC 2236 only mentions 'Query' and does not specify GQ or GSQ. Can a querier transition take place based on GSQ? Or is it okay to for a querier to ignore GSQ? Can anyone please help me with this?

Thanks,
Indranil

**************** CAUTION - Disclaimer *****************
This e-mail contains PRIVILEGED AND CONFIDENTIAL INFORMATION intended solely
for the use of the addressee(s). If you are not the intended recipient, please
notify the sender by e-mail and delete the original message. Further, you are not
to copy, disclose, or distribute this e-mail or its contents to any other person and
any such actions are unlawful. This e-mail may contain viruses. Infosys has taken
every reasonable precaution to minimize this risk, but is not liable for any damage
you may sustain as a result of any virus in this e-mail. You should carry out your
own virus checks before opening the e-mail or attachment. Infosys reserves the
right to monitor and review the content of all messages sent to or from this e-mail
address. Messages sent to or from this e-mail address may be stored on the
Infosys e-mail system.
***INFOSYS******** End of Disclaimer ********INFOSYS***

_______________________________________________
magma mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/magma

---

From: "V, Magesh (Magesh)" <[email-masked]>
Date: Wed, 1 Feb 2012 18:35:04 +0530

Hi,

<<<<<<<<<<<<<<<<<<<<

Thanks,
Magesh.

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Bharat Joshi
Sent: Tuesday, January 31, 2012 7:39 PM
To: Indranil Bhattacharya
Cc: [email-masked]
Subject: Re: [magma] Querier transition based on Group Specific Query?

Indranil.

Regards,
Bharat

Hi Bharat,

0x11 = Membership Query

Thanks,
Indranil

Regards,
Bharat

Hi Bharat,

Thanks,
Indranil

       This is what is available in RFC 2236:

<<<

Regards,
Bharat

Hi,

Thanks,
Indranil

---

From: "V, Magesh (Magesh)" <[email-masked]>
Date: Wed, 1 Feb 2012 19:05:55 +0530

Hi Bharat,
A GSQ is an event triggered action (Leave Msg). 'N' number of groups can leave at different points in time for which, GSQs will be triggered. It would be un-necessary overhead in running the querier election logic for every such GSQ.

When it is clearly given what to do for a GSQ then the only other query msg type left is 'Gen Query'. Hence, I would interpret 'lower ip query msg' to be only 'Gen Query' for the election process.

Thanks,
Magesh.

-----Original Message-----
From: Bharat Joshi [mailto:[email-masked]] 
Sent: Wednesday, February 01, 2012 6:48 PM
To: V, Magesh (Magesh); Indranil Bhattacharya
Cc: [email-masked]
Subject: RE: [magma] Querier transition based on Group Specific Query?

Magesh,

       The snippet you have copied in your mail is from the last para of section 3 of RFC 2236. In the same section, in second para of the same section, we have following text:

<<<<

Regards,
Bharat

Hi,

<<<<<<<<<<<<<<<<<<<<

Thanks,
Magesh.

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Bharat Joshi
Sent: Tuesday, January 31, 2012 7:39 PM
To: Indranil Bhattacharya
Cc: [email-masked]
Subject: Re: [magma] Querier transition based on Group Specific Query?

Indranil.

Regards,
Bharat

Hi Bharat,

0x11 = Membership Query

Thanks,
Indranil

Regards,
Bharat

Hi Bharat,

Thanks,
Indranil

       This is what is available in RFC 2236:

<<<

Regards,
Bharat

Hi,

Thanks,
Indranil

---

From: Bharat Joshi <[email-masked]>
Date: Wed, 1 Feb 2012 19:15:43 +0530

Magesh,

        Now that we know it is not clear in RFC, I think it depends upon the individual interpretation of the text.

        My interpretation has come from the following snippet in RFC,

         It says 'IGMP Membership Query' here and in this RFC, this term is defined to mean either General or Group-Specific query.

         BTW, If you do a google search of this term, all top few results will say that it means 'General query'.

Regards,
Bharat
Sent: Wednesday, February 01, 2012 7:05 PM

Hi Bharat,

Thanks,
Magesh.

-----Original Message-----
From: Bharat Joshi [mailto:[email-masked]]
Sent: Wednesday, February 01, 2012 6:48 PM
To: V, Magesh (Magesh); Indranil Bhattacharya
Cc: [email-masked]
Subject: RE: [magma] Querier transition based on Group Specific Query?

Magesh,

       The snippet you have copied in your mail is from the last para of section 3 of RFC 2236. In the same section, in second para of the same section, we have following text:

<<<<

Regards,
Bharat

Hi,

<<<<<<<<<<<<<<<<<<<<

Thanks,
Magesh.

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Bharat Joshi
Sent: Tuesday, January 31, 2012 7:39 PM
To: Indranil Bhattacharya
Cc: [email-masked]
Subject: Re: [magma] Querier transition based on Group Specific Query?

Indranil.

Regards,
Bharat

Hi Bharat,

0x11 = Membership Query

Thanks,
Indranil

Regards,
Bharat

Hi Bharat,

Thanks,
Indranil

       This is what is available in RFC 2236:

<<<

Regards,
Bharat

Hi,

Thanks,
Indranil